require "nServer"

local Ptr=nServer.Ptr
local peek=nServer.peek
local int2num=nServer.int2num
local str2ul=nServer.str2ul
local call=nServer.call

OS = string.format("%X",int2num(peek("0x10000020",4)))
if OS == "102F0FA0" then
 show_msgUserInput = "0X107A3FE8" -- 3.1.0 non-CAS
end
if OS == "102F16D0" then
 show_msgUserInput = "0X107E3FF8" -- 3.1.0 CAS
end
if OS == "102F0A10" then
 show_msgUserInput = "0X10784FD4" -- 3.1.0 non-CAS CX
end
if OS == "102F11A0" then
 show_msgUserInput = "0X107E128C" -- 3.1.0 CAS CX
end



collectgarbage("stop")  -- So Lua does not move the string "str"

request_value = "d\0e\0f\0a\0u\0l\0t\0 \0v\0a\0l\0u\0e\0\0\0"
title16 = "L\0u\0a\0 \0N\0a\0t\0i\0v\0e\0 \0c\0a\0l\0l\0\0\0"
msg16 =   "S\0t\0r\0i\0n\0g\0\0\0"
ptrref1 = str2ul(Ptr(msg16))
ptrref2 = str2ul(Ptr(request_value))
request_struct = str2ul(Ptr(ptrref1)) .. str2ul(Ptr(ptrref2)) 
ret = call(show_msgUserInput,0,Ptr(request_struct),Ptr(title16),Ptr(msg16))  -- run it
strout =  peek(string.format("0X%X",(int2num(ptrref2))),20)


collectgarbage("restart") -- continue garbage
-- i am lazy here 
value = string.sub(strout,1,1) .. string.sub(strout,3,3) .. string.sub(strout,5,5) .. string.sub(strout,7,7) .. string.sub(strout,9,9) .. string.sub(strout,11,11)

function on.paint(gc)
    gc:drawString("Lua native function tests",5,5,"top")  
    gc:drawString("msgUserInput returned:"..value,5,20,"top")  
    gc:drawString("OS:" .. OS,5,35,"top") 
end