require "nServer"

local Ptr=nServer.Ptr
local peek=nServer.peek
local int2num=nServer.int2num
local call=nServer.call

OS = string.format("%X",int2num(peek("0x10000020",4)))
if OS == "102F0FA0" then
 puts = "0x102F0FA0" -- 3.1.0 non-CAS
end
if OS == "102F16D0" then
 puts = "0x102F16D0" -- 3.1.0 CAS
end
if OS == "102F0A10" then
 puts = "0x10378284" -- 3.1.0 non-CAS CX
end
if OS == "102F11A0" then
 puts = "0x102F11A0" -- 3.1.0 CAS CX
end


str = "---- String to print -----"


collectgarbage("stop")  -- So Lua does not move the string "str"
call(puts,Ptr(str))  -- run it: puts("String to print");
collectgarbage("restart") -- continue garbage

function on.paint(gc)
    gc:drawString("Lua native function tests",5,5,"top")  -- display string
    collectgarbage("stop")  -- So Lua does not move the string "testvar"
    gc:drawString(string.format("string at %X",Ptr(str)),5,20,"top")  -- display string
    collectgarbage("restart") -- continue garbage
    gc:drawString("OS:" .. OS,5,35,"top") 
end